<?php

namespace App\Http\Controllers\Survey;

use App\Http\Controllers\Controller;
use App\Interfaces\Survey\IType;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class TypeController extends Controller
{

    protected $survey_type;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(IType $type)
    {
        
        $this->survey_type = $type;
    }

    
    public function activeTypes()
    {
        $response = $this->survey_type->activeType();
        
        return $this->sendHttpStatusResponse($response->body, $response->status_code);
    }

    public function Types()
    {
        $response = $this->survey_type->allType();

        return $this->sendHttpStatusResponse($response->body, $response->status_code);
    }

    public function createType(Request $request)
    {
        $validate = Validator::make($request->all(), [
            'survey_type'=> 'required'
        ]);

        if($validate->fails()){
            return $this->sendError("Validation Error - {$validate->errors()->first()}", $validate->errors());
        }

        $response = $this->survey_type->createType($request->all());

        return $this->sendHttpStatusResponse($response->body, $response->status_code);

    }

    public function updateType(Request $request, $id)
    {
        $validate = Validator::make($request->all(), [
            'survey_type' => 'required'
        ]);

        if ($validate->fails()) {
            return $this->sendError("Validation Error - {$validate->errors()->first()}", $validate->errors());
        }


        $response = $this->survey_type->updateType($request->all(), $id);

        return $this->sendHttpStatusResponse($response->body, $response->status_code);
    }


    public function disable_type($id)
    {
        $response = $this->survey_type->disableType($id);

        return $this->sendHttpStatusResponse($response->body, $response->status_code);
    }

    public function enable_type($id)
    {
        $response = $this->survey_type->enableType($id);

        return $this->sendHttpStatusResponse($response->body, $response->status_code);
    }
    
}
