<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\DB;

class UserCheck
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $user = $request->header('user_id');
        $client_slug = $request->header('client_slug');

        $client = DB::table('clients')->where('client_slug', $client_slug)->first();

        if(is_null($client)){
            return response()->json([
                'message'=> 'Access Denied',
                'status'=> 0,
                'status_code'=> 403
            ], 403);
        }

        $check_user = DB::table('users')->where('id', $user)->where('client_id', $client->id)->first();

        if(is_null($check_user)){
            return response()->json([
                'message' => 'Access Denied',
                'status' => 0,
                'status_code' => 403
            ], 403);
        }

        $request->client_id = $client->id;
        $request->user_id = $user;
        return $next($request);
    }
}
