<?php

namespace App\Repo;

use App\Interfaces\ILicense;

class LicenseRepo extends BaseRepo implements ILicense
{
    public $makeRequest;

    public function __construct($table_name = "license")
    {
        parent::__construct($table_name);
        $base_url = env("SURVEY_ENGINE_URL");
        $this->makeRequest = new MakeRequest($base_url);
        $this->token = env('ADMIN_TOKEN');
    }


    public function license()
    {
        return $this->makeRequest->getAsJson("license", [
            'client-Key'=> $this->token
        ]);
    }

   public function findlicense(int $id)
   {
       return $this->makeRequest->getAsJson("license/find/{$id}", [
            'client-Key'=> $this->token
       ]);
   }

   public function createLicense(array $data)
   {
       return $this->makeRequest->postAsJson("license/create",$data, [
            'client-Key'=> $this->token
       ]);
   }

   public function updateLicense(array $data, $id)
   {
       return $this->makeRequest->postAsJson("license/update/{$id}", $data, [
            'client-Key' => $this->token
       ]);
   }

   public function disableLicense($id)
   {
       return $this->makeRequest->postAsJson("license/disable/{$id}", [], [
            'client-Key'=> $this->token
       ]);
   }

   public function enableLicense($id)
   {
       return $this->makeRequest->postAsJson("license/enable/{$id}", [], [
            'client-Key'=> $this->token
       ]);
   }

   public function renewLicense(array $data)
   {
       return $this->makeRequest->postAsJson("license/renew", $data, [
            'client-Key'=> $this->token
       ]);
   }

    public function runninglicense()
    {
        return $this->makeRequest->getAsJson("license/running/clients", [
            'client-Key' => $this->token
        ]);  
    }

    public function expiredlicense()
    {
        return $this->makeRequest->getAsJson("license/expired/clients",[
            'client-Key' => $this->token
        ]);
    }

    public function licensehistory($client_slug)
    {
        return $this->makeRequest->getAsJson("license/{$client_slug}/history", [
            'client-Key' => $this->token
        ]);
    }
   
}
