<?php

namespace App\Repo\SurveyRepo;

use App\Interfaces\Survey\IType;
use App\Repo\BaseRepo;
use App\Repo\MakeRequest;

class TypeRepo extends BaseRepo implements IType
{

    public $token, $apiKey;

    public $makeRequest;
    
    public function __construct($table_name = "type")
    {
        parent::__construct($table_name);
        $base_url = env("SURVEY_ENGINE_URL");
        $this->makeRequest = new MakeRequest($base_url);
        $this->token = env('ADMIN_TOKEN');
        $this->apiKey  = env('APIKEY');
    }

    public function activeType()
    {
        return $this->makeRequest->getAsJson("survey_types/active", [
            'client-Key'=> $this->token       
         ]);
    }

    public function allType()
    {
        return $this->makeRequest->getAsJson("survey_types", [
            'client-Key' => $this->token
        ]);
    }

    public function createType(array $data)
    {
        return $this->makeRequest->postAsJson("survey_types", $data, [
            'client-Key'=> $this->token
        ]);
    }

    public function updateType(array $data, int $id)
    {
        return $this->makeRequest->postAsJson("survey_types/{$id}/update", $data, [
            'client-Key' => $this->token 
        ]);
    }

    public function disableType(int $id)
    {
        return $this->makeRequest->postAsJson("survey_types/{$id}/disable", [], [
            'client-Key'=> $this->token       
         ]);
    }

    public function enableType(int $id)
    {
        return $this->makeRequest->postAsJson("survey_types/{$id}/enable", [], [
            'client-Key' => $this->token
        ]);
    }





}
