<?php


namespace App\Traits;


trait HttpErrorTrait
{
    public function formulateErrorResponse($ex)
    {


        $status_code = $ex->getCode();

        switch ($status_code) {
            case 404:
                return (object) ([
                    'body' => (object) ["message" => "Route not found", "reason" => $ex->getMessage()],
                    'status_code' => $status_code
                ]);
            case 401:
                $body = json_decode($ex->getResponse()->getBody()->getContents());
                return (object) ([
                    'body' => $body,
                    'status_code' => $status_code
                ]);
            case 400:
                $body = json_decode($ex->getResponse()->getBody()->getContents());
                return (object) ([
                    'body' => $body,
                    'status_code' => $status_code
                ]);
            case 422:
                $body = json_decode($ex->getResponse()->getBody()->getContents());
                return (object) ([
                    'body' => $body,
                    'status_code' => 400
                ]);
            case 403:

                $message = json_decode($ex->getResponse())->message;
                return (object) ([
                    'body' => (object) ['message' => "User is forbidden to make this request"],
                    'status_code' => $status_code
                ]);
            case $status_code >= 405 && $status_code < 500:

                $message = $ex->getMessage();
                return (object) ([
                    'body' => (object) ['message' => $message],
                    'status_code' => $status_code
                ]);
            default:

                return (object) ([
                    'body' => (object) [
                        "message" => "A server error occurred please try again or contact the system administrator",
                        // "reason" => $ex->getMessage()
                    ],
                    'status_code' => $status_code
                ]);
        }
    }
}
